<?php
/*------------------------------------------------------------------------
# mod_qmininews - Q-Mininews
# ------------------------------------------------------------------------
# author    NetQ Creative Software
# copyright Copyright (C) 2010 netqcreative.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.netqcreative.com
# Technical Support:  Forum - http://www.netqcreative.com/Support/
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die ('Restricted access');
jimport( 'joomla.utilities.string' );
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
class modQminiNewsHelper{
	function getList(&$params)
	{
		global $mainframe;

		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$aid	= $user->get('aid', 0);

		$catid 	= (int) $params->get('catid', 0);
		$count		= (int) $params->get('count', 2);
		
		$order		    = $params->get('order', 0);
		$order_type	  = $params->get('order_type', 'asc');

		$contentConfig	= &JComponentHelper::getParams('com_content');

		$date =& JFactory::getDate();
		$now = $date->toMySQL();

		$nullDate = $db->getNullDate();
		

		// query to determine article count
		if ($catid == 0 || empty($catid)) {
			$cat ="";
		}else {
			$cat = ' AND cc.id = '. (int) $catid;
		}
		
		switch($order) {
			case 0:
				$orderby = "a.created " . $order_type;
				break;
			case 1:
				$orderby = "a.modified " . $order_type;
				break;	
			case 2:
				$orderby  = "a.hits " . $order_type;
				break;
			case 3:
				$orderby  = "a.ordering " . $order_type;
				break;
			default:
				$orderby  = "RAND()";
				break;
		}
		
		$query = 'SELECT a.*,' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' FROM #__content AS a' .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE a.state = 1 ' .
			' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' ) ' .
			' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )' .
			 $cat .
			' AND cc.section = s.id' .
			' AND cc.published = 1' .
			' AND s.published = 1' .
			' ORDER BY '. $orderby;
			
		$db->setQuery($query, 0, $count);
		$rows = $db->loadObjectList();
		$i = 0;
		$lists	= array();
		foreach ($rows as $row)
		{
			$lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
			
			$lists[$i]->title = htmlspecialchars( $row->title );
			
			$lists[$i]->ct= strip_tags(preg_replace('/<img([^>]+)>/i',"",$row->introtext));//load introtext and remove images
			
			$lists[$i]->content = substring($lists[$i]->ct, $params->get('textlimit'));
			
			preg_match_all('/src="([^"]+)"/i', $row->introtext . $row->fulltext, $matches);// load the first image from introtex or fulltext
			
			if (empty($matches[1][0])) {
				$lists[$i]->im = "";
			}else {
				$lists[$i]->im = $matches[1][0];//show image
			}
			
			if ($params->get('showthumbnails') == 1) {
				$lists[$i]->images = '<img class="qmininews-img-thumb" src="'.$lists[$i]->im.'" width="'.$params->get('imagewidth').'" height="'.$params->get('imageheight').'" alt="'.$lists[$i]->title.'" />';//show images
			}else {
				$lists[$i]->images = "";
			}
			
			if (($params->get('showdefaultthubnail') == 1) && ($params->get('showthumbnails') == 1) && empty($lists[$i]->im)) {// display default image
				$lists[$i]->images = '<img class="qmininews-img-thumb" src="'.$params->get('thumnaildefault').'" width="'.$params->get('imagewidth').'" height="'.$params->get('imageheight').'" alt="'.$lists[$i]->title.'" />';
			}
			
			$i++;
		}
		
		return $lists;
	}
}
function substring($str,$leng){
	
	if(JString::strlen($str)<=$leng)	{
	    return $str;
	} else {
	    if(JString::strpos($str," ",$leng) > $leng) {
	        $new_leng=JString::strpos($str," ",$leng);
	        $new_str = JString::substr($str,0,$new_leng)."...";
	        return $new_str;
	    }
	    $new_str = JString::substr($str,0,$leng)."...";
	    return $new_str;
	}
}
?>
